
import { Loading } from 'element-ui';

export default {
props:{
    orderNumber:'',
    capacityNumber:'',
},
data() {
    return {
        loading : null,
       
    };
},
watch:{
    orderNumber:{
         deep: true,
        handler(val, oldVal) {
            console.log("111111111234646")
            this.reloadData();
        }
    }
},
created(){
  
     this.reloadData();
},
mounted: function () {
             
        },
methods: {
    startLoading (){
        this.loading = Loading.service({ lock: true, text: '加载中……', background: 'rgba(0, 0, 0, 0.7)' });
    },
    reloadData() {
        let resultData = {
            orderNumber: this.orderNumber,
        };
        this.startLoading(this.orderNumber);
        console.log()
        this.$axios.post(
            "api/v1/getway/fullPathVisualization",resultData
            ).then((res) => {
            this.loading.close(); 
            if(res.data.startAndEndRoutes!=null){
                this.initMap(res.data);

            
            }else{
                this.$message('车辆未入网或没有开启定位，不能访问');
                this.newMap();
            }
            
            
        })
        .catch(error => {
                this.loading.close(); 
               
            if((error+"").indexOf("500") !== -1){
                    this.$message('车辆未入网或没有开启定位，不能访问');
                    this.newMap();
            }
                    
                    
            
            });
        
        
            
        },
        newMap(){
                var currentPointLat='32.483276';
                var currentPointLon='114.03629';
                this.map = new AMap.Map('container', {
                    zoom:11,//级别
                    center: [currentPointLon,currentPointLat],//中心点坐标
                    viewMode:'3D'//使用3D视图
                });
                var content = [
                        "<div  style='top:1px;width: 180px; background-color: rgba(0, 0, 0, 1);' ><b>"+this.capacityNumber+")</b>",
                        "<div style='background-color:rgba(255, 255, 255, 0.5);'>提示 :"+'GPS没有开启'+"</div></div>"
                
                ];

                // 创建 infoWindow 实例	
                var infoWindow = new AMap.InfoWindow({
                content: content.join("<br>")  //传入 dom 对象，或者 html 字符串
                });
                
                // 打开信息窗体
                infoWindow.open(this.map,[currentPointLon,currentPointLat]);
               
               
        },
        //startLonlat=114.03629,32.483276
        initMap(data) {
            console.log(1)
                var currentPointLat='32.483276';
                var currentPointLon='114.03629';
                var polyline=[];
                //初始化地图
                if (data.startAndEndRoutes[0].currentPoint!=null){
                    currentPointLat=data.startAndEndRoutes[0].currentPoint.lat;
                    currentPointLon=data.startAndEndRoutes[0].currentPoint.lon;
                }
                
            
            
                this.map = new AMap.Map('container', {
                    zoom:11,//级别
                    center: [currentPointLon,currentPointLat],//中心点坐标
                    viewMode:'3D'//使用3D视图
                });
                var limeList= [];
            
                data.startAndEndRoutes.forEach((element,index) => {
                    
                    var startPaths=[];
                    element.runRoute.forEach((element,index) => {
                        var path= [element.lon,element.lat];
                        startPaths.push(path);
                    });
                
                    var endPaths=[];
                    if(element.estimateRoute!=null){
                        element.estimateRoute.forEach((element,index) => {
                        var path= [element.lon,element.lat]
                        endPaths.push(path);
                    });
                    }
                    if (element.startPoint!=null){
                    
                        //当前点图标标记点
                        let startPointicon = new AMap.Icon({
                            size: new AMap.Size(25, 35), // 图标尺寸
                            image: require('@/assets/img/start.png'), // Icon的图像
                            imageOffset: new AMap.Pixel(0,0), // 图像相对展示区域的偏移量，适于雪碧图等
                            imageSize: new AMap.Size(25, 35) // 根据所设置的大小拉伸或压缩图片
                        });
                        // 创建一个 Marker 实例：
                        var startPointmarker = new AMap.Marker({
                            position: new AMap.LngLat(element.startPoint.lon, element.startPoint.lat),   // 经纬度对象，也可以是经纬度构成的一维数组[116.39, 39.9]
                                icon: startPointicon, 
                            title: '北京'
                        });
                        // 将创建的点标记添加到已有的地图实例：
                        this.map.add(startPointmarker);
                    }
            



                
        

                    
            
                    //终点
                    if (element.endPoint!=null){

                        //当前点图标标记点
                        let endPointicon = new AMap.Icon({
                            size: new AMap.Size(25, 35), // 图标尺寸
                            image: require('@/assets/img/end.png'), // Icon的图像
                            imageOffset: new AMap.Pixel(0,0), // 图像相对展示区域的偏移量，适于雪碧图等
                            imageSize: new AMap.Size(25, 35) // 根据所设置的大小拉伸或压缩图片
                        });
                        // 创建一个 Marker 实例：
                        var endPointmarker = new AMap.Marker({
                            position: new AMap.LngLat(element.endPoint.lon, element.endPoint.lat),   // 经纬度对象，也可以是经纬度构成的一维数组[116.39, 39.9]
                                icon: endPointicon, 
                            title: '北京'
                        });

                        // 将创建的点标记添加到已有的地图实例：
                        this.map.add(endPointmarker);
                    }
                    
                
                //已行驶轨迹
                    if(startPaths.length>0){
                    
                        var startLine = new AMap.Polyline({
                            map:this.map,
                            path: startPaths,
                            isOutline: true,
                            outlineColor: '#00FF00',
                            borderWeight: 0,
                            strokeColor: "#00FF00", 
                            strokeOpacity: 1,
                            strokeWeight: 5,
                            // 折线样式还支持 'dashed'
                            strokeStyle: "solid",
                            // strokeStyle是dashed时有效
                            strokeDasharray: [10, 5],
                            lineJoin: 'round',
                            lineCap: 'round',
                            zIndex: 50,
                        })
                        
                        limeList.push(startLine);
                        
                    }

                if(endPaths.length>0){
                    
                        //预计轨迹
                    
                        var endLine = new AMap.Polyline({
                            map:this.map,
                            path: endPaths,
                            isOutline: true,
                            outlineColor: '#FF0000',
                            borderWeight: 0,
                            strokeColor: "#FF0000", 
                            strokeOpacity: 1,
                            strokeWeight: 5,
                            // 折线样式还支持 'dashed'
                            strokeStyle: "solid",
                            // strokeStyle是dashed时有效
                            strokeDasharray: [10, 5],
                            lineJoin: 'round',
                            lineCap: 'round',
                            zIndex: 50,
                        })
                        limeList.push(endLine);
                    
                }
                    
                });

                
                var content = [
                        "<div  style='top:1px;width: 180px; background-color: rgba(0, 0, 0, 1);' ><font color='white'>"+this.capacityNumber+'('+data.startAndEndRoutes[0].miled+")</font>",
                        "<div style='background-color:rgba(255, 255, 255, 0.5);'><font color='white'>地址 :"+data.startAndEndRoutes[0].currentPointName+"</font></div></div>"
                
                ];
                data.startAndEndRoutes.forEach((element,index) => {
                        // 创建 infoWindow 实例	
                        var infoWindow = new AMap.InfoWindow({
                        content: content.join("<br>")  //传入 dom 对象，或者 html 字符串
                        });
                      

                       //当前点图标标记点
                    let currentPointicon = new AMap.Icon({
                        size: new AMap.Size(40, 40), // 图标尺寸
                        image: require('@/assets/img/car1.png'), // Icon的图像
                        imageOffset: new AMap.Pixel(0,0), // 图像相对展示区域的偏移量，适于雪碧图等
                        imageSize: new AMap.Size(40, 40) // 根据所设置的大小拉伸或压缩图片
                    });
                    // 创建一个 Marker 实例：
                    var currentPointmarker = new AMap.Marker({
                        position: new AMap.LngLat(element.runRoute[element.runRoute.length-1].lon,element.runRoute[element.runRoute.length-1].lat),   // 经纬度对象，也可以是经纬度构成的一维数组[116.39, 39.9]
                            icon: currentPointicon, 
                        title: '北京'
                    });

                    // 将创建的点标记添加到已有的地图实例：
                    this.map.add(currentPointmarker);
                        // 打开信息窗体
                        infoWindow.open(this.map,[element.runRoute[element.runRoute.length-1].lon,element.runRoute[element.runRoute.length-1].lat]);
                });
                
            
                this.map.setFitView([ limeList ])



        

            
            
                
                // 缩放地图到合适的视野级别
        
            }
    }
};